                                                                                
(*#########################*)
 IMPLEMENTATION MODULE Set0;     (* v2.0-060297 *)
(*#########################*)
                                                                                
(*
NOTE:  1.Better leave bounds checking on!

VERSION HISTORY

v1.0-012584       
v2.0-060297  -Changed use of WORD to CARDINAL.
*)
                                                                                
CONST  Last       = (MaxElements DIV BitSetSize) - 1;

(*-------------------------------------*)
PROCEDURE SetIncl(E:CARDINAL; VAR S:BigSet);
(*-------------------------------------*)
                                                                                
BEGIN
                                                                                
INCL(S[E DIV BitSetSize], E MOD BitSetSize);
                                                                                
END SetIncl;
                                                                                
(*-------------------------------------*)
PROCEDURE SetExcl(E:CARDINAL; VAR S:BigSet);
(*-------------------------------------*)
                                                                                
BEGIN
                                                                                
EXCL(S[E DIV BitSetSize], E MOD BitSetSize);

END SetExcl;
                                                                                
(*------------------------------------*)
PROCEDURE SetUnion(VAR S1,S2,S:BigSet);
(*------------------------------------*)
                                                                                
VAR i       :[0..Last];

BEGIN
                                                                                
FOR i := 0 TO Last DO
   S[i] := S1[i] + S2[i];
END;
                                                                                
END SetUnion;
                                                                                
(*----------------------------------------*)
PROCEDURE SetIntersect(VAR S1,S2,S:BigSet);
(*----------------------------------------*)
                                                                                
VAR i       :[0..Last];

BEGIN
                                                                                
FOR i := 0 TO Last DO
     S[i] := S1[i] * S2[i];
     END;
                                                                                
END SetIntersect;
                                                                                
(*-----------------------------------*)
PROCEDURE SetDiff(VAR S1,S2,S:BigSet);
(*-----------------------------------*)

VAR i       :[0..Last];
                                                                                
BEGIN
                                                                                
FOR i := 0 TO Last DO
   S[i] := S1[i] - S2[i];
 END;
                                                                                
END SetDiff;
                                                                                
(*---------------------------------------*)
PROCEDURE SetSymmDiff(VAR S1,S2,S:BigSet);
(*---------------------------------------*)

VAR i       :[0..Last];
                                                                                
BEGIN
                                                                                
FOR i := 0 TO Last DO
   S[i] := S1[i] / S2[i];
END;
                                                                                
END SetSymmDiff;
                                                                                
(*-------------------------------------------*)
PROCEDURE SetIn(E:CARDINAL; VAR S:BigSet):BOOLEAN;
(*-------------------------------------------*)
                                                                                
BEGIN
                                                                                
RETURN (E MOD BitSetSize) IN S[E DIV BitSetSize]
                                                                                
END SetIn;
                                                                                
(*---------------------------------------*)
PROCEDURE SetEq(VAR S1,S2:BigSet):BOOLEAN;
(*---------------------------------------*)

VAR i       :[0..Last];
                                                                                
BEGIN
                                                                                
FOR i := 0 TO Last DO
   IF S1[i] # S2[i] THEN
      RETURN FALSE;
   END;
END;
                                                                                
RETURN TRUE;
                                                                                
END SetEq;
                                                                                
(*----------------------------------------*)
PROCEDURE SetSub(VAR S1,S2:BigSet):BOOLEAN;
(*----------------------------------------*)
(* Is S2 contained in S1 ? *)

VAR i       :[0..Last];
                                                                                                                                                                
BEGIN
                                                                                
FOR i := 0 TO Last DO
   IF (S1[i] * S2[i]) # S2[i] THEN
      RETURN FALSE;
   END;
END;
                                                                                
RETURN TRUE;
                                                                                
END SetSub;
                                                                                
(*------------------------------------------*)
PROCEDURE SetIncl2(E1,E2:CARDINAL; VAR S:BigSet);
(*------------------------------------------*)
                                                                                
BEGIN
                                                                                
SetIncl(E1,S); SetIncl(E2,S);
                                                                                
END SetIncl2;
                                                                                
(*------------------------------------------------*)
PROCEDURE SetIncl4(E1,E2,E3,E4:CARDINAL; VAR S:BigSet);
(*------------------------------------------------*)
                                                                                
BEGIN
                                                                                
SetIncl2(E1,E2,S); SetIncl2(E3,E4,S);
                                                                                
END SetIncl4;
                                                                                
(*------------------------------------------------------------*)
PROCEDURE SetIncl8(E1,E2,E3,E4,E5,E6,E7,E8:CARDINAL; VAR S:BigSet);
(*------------------------------------------------------------*)
                                                                                
BEGIN
                                                                                
SetIncl4(E1,E2,E3,E4,S); SetIncl4(E5,E6,E7,E8,S);
                                                                                
END SetIncl8;
                                                                                
(* ?S- *)
VAR i       :[0..Last];

BEGIN

FOR i := 0 TO Last DO
   NullBigSet[i] := BITSET{};
END;
                                                                                
END Set0.
